////////////////////////////////////////////////////////////
//CAddDragDrop - declaration file

#ifndef __ADDDROP_H__
#define __ADDDROP_H__

#include "MyTarget.h"

//MACRO - put this one inside the BEGIN_MESSAGE_MAP, END_MESSAGE_MAP
//macros to add the extra handler
#define DROPMESSAGES() \
    ON_MESSAGE(WM_DRAGOP,OnDragOp) \

//MACRO - put this one inside the class definition.  Watch the 
//access control.  This sets the access to protected at the end.  
//This declares and defines the message handler and the drop target 
//member.
#define DROPHANDLERS() \
public:\
    BOOL RegisterDrop() {return m_DropTarg.Register(this);}\
    CMyOleDropTarget m_DropTarg;\
protected:\
    afx_msg long OnDragOp(WPARAM wP,LPARAM lP) \
        {return DragOperation(wP,lP);} \

//Add on class.  Multiply and Publicly inherit this class
//eg. class CMyWnd:public CWnd,public DAdDrop { ... };
class DAddDrop{
public:
    DAddDrop() {};

    //virtual OnDrag_xxx functions
    virtual DROPEFFECT	OnDragOver( COleDataObject* pDataObject, 
                                    DWORD dwKeyState, CPoint point ) 
        {return DROPEFFECT_NONE;}
    virtual DROPEFFECT	OnDragEnter( COleDataObject* pDataObject, 
                                     DWORD dwKeyState, CPoint point )
        {return DROPEFFECT_NONE;}
    virtual void OnDragLeave() {};
    virtual BOOL OnDrop(COleDataObject* pDataObject,
                        DROPEFFECT dropEffect,CPoint point) 
        {return FALSE;}

protected:
    long DragOperation(UINT DragOp,LPARAM lInfoPtr);
};
#endif   //__ADDDROP_H__

