//////////////////////////////////////////////////////
//CMyOleDropTarget - header file

#ifndef __DAROLEDROPTARGET_H__
#define __DAROLEDROPTARGET_H__

#define WM_DRAGOP    (WM_USER + 55)

#define DRAGOP_DRAGOVER	0
#define DRAGOP_DROP     1
#define DRAGOP_ENTER    2
#define DRAGOP_LEAVE    3
#define DRAGOP_SCROLL	4

//structure that contains all the drag and drop info passed
//by OnDragOver, etc.
struct SDropInfo{
    SDropInfo() {d_effect = DROPEFFECT_NONE;
                pOleObj = NULL;
                point.x = 0;
                point.y = 0;
                KeyState = 0;}

    DROPEFFECT	        d_effect;
    POINT               point;
    COleDataObject*     pOleObj;
    DWORD               KeyState;
};

//Extended drop target class.
class CMyOleDropTarget:public COleDropTarget{
public:
    CMyOleDropTarget();
    ~CMyOleDropTarget();
    
    //overridden functions
    virtual DROPEFFECT OnDragOver(CWnd* pWnd, 
                                  COleDataObject* pDataObject,
                                  DWORD dwKeyState,CPoint point);
    virtual DROPEFFECT OnDragEnter( CWnd* pWnd, 
                                    COleDataObject* pDataObject, 
                                    DWORD dwKeyState, CPoint point );
    virtual void OnDragLeave(CWnd *pWnd);
    virtual BOOL OnDrop( CWnd* pWnd, COleDataObject* pDataObject, 
                         DROPEFFECT dropEffect, CPoint point );

protected:
    SDropInfo *m_pInfo;
};

#endif

