#include "NicLib.h"

#define N_WVSPRINTF         1024

#define WS_VERSION          0x0101
#define VNS_BYCALLOK        0


typedef struct _ADAPTER_DATA
    {
    ADAPTER_STATUS as;
    NAME_BUFFER    nb [30];
    }
    ADAPTER_DATA, *PADAPTER_DATA;


TBYTE atHex [] = "0123456789ABCDEF";


int WINAPI NicBox (HWND   hWnd,
                   UINT   uType,
                   PTBYTE ptCaption,
                   PTBYTE ptFormat,
                   ...)
    {
    TBYTE atBuffer [N_WVSPRINTF];
    PVOID pArgs = &ptFormat + 1;

    wvsprintf (atBuffer, ptFormat, pArgs);
    return MessageBox (hWnd, atBuffer, ptCaption, uType);
    }

// -----------------------------------------------------------------

BOOL WINAPI NicAddressNetbios (BYTE abAddress [N_NIC_ADDRESS])
    {
    HMODULE      hModule;
    PROC         Netbios;
    NCB          ncb;
    LANA_ENUM    le;
    ADAPTER_DATA ad;
    BYTE         abRas [] = "DEST\0\0";
    DWORD        i, j, k, l;
    BOOL         fOk = FALSE;

    hModule = LoadLibrary ("NETAPI32.dll");
    if (hModule != NULL)
        {
        Netbios = GetProcAddress (hModule, "Netbios");
        if (Netbios != NULL)
            {
            ZeroMemory (&ncb, sizeof (ncb));
            ncb.ncb_command = NCBENUM;
            ncb.ncb_buffer  = (PBYTE) &le;
            ncb.ncb_length  = sizeof (le);

            if (Netbios (&ncb) == NRC_GOODRET)
                {
                for (i = 0; i < le.length; i++)
                    {
                    ZeroMemory (&ncb, sizeof (ncb));
                    ncb.ncb_command  = NCBRESET;
                    ncb.ncb_lana_num = le.lana [i];

                    if (Netbios (&ncb) == NRC_GOODRET)
                        {
                        ZeroMemory (&ncb, sizeof (ncb));
                        ncb.ncb_command  = NCBASTAT;
                        ncb.ncb_lana_num = le.lana [i];
                        ncb.ncb_buffer   = (PBYTE) &ad;
                        ncb.ncb_length   = sizeof (ad);

                        FillMemory (ncb.ncb_callname,
                                    NCBNAMSZ, ' ');

                        ncb.ncb_callname [0] = '*';

                        if (Netbios (&ncb) == NRC_GOODRET)
                            {
                            for (j = k = l = 0;
                                 j < N_NIC_ADDRESS;
                                 j++)
                                {
                                abAddress [j] =
                                    ad.as.adapter_address [j];

                                if (abAddress [j] == 0        ) k++;
                                if (abAddress [j] == abRas [j]) l++;
                                }
                            if (fOk = ((k < j) && (l < j))) break;
                            }
                        }
                    }
                }
            }
        FreeLibrary (hModule);
        }
    return fOk;
    }

// -----------------------------------------------------------------

BOOL WINAPI NicAddressNetware (BYTE abAddress [N_NIC_ADDRESS])
    {
    HMODULE      hModule;
    PROC         WSAStartup, WSACleanup;
    PROC         socket, closesocket, bind, getsockname;
    WSADATA      wd;
    SOCKET       s;
    SOCKADDR_IPX sai;
    DWORD        n;
    BOOL         fOk = FALSE;

    hModule = LoadLibrary ("WSOCK32.dll");
    if (hModule != NULL)
        {
        WSAStartup  = GetProcAddress (hModule, "WSAStartup");
        WSACleanup  = GetProcAddress (hModule, "WSACleanup");
        socket      = GetProcAddress (hModule, "socket");
        closesocket = GetProcAddress (hModule, "closesocket");
        bind        = GetProcAddress (hModule, "bind");
        getsockname = GetProcAddress (hModule, "getsockname");

        if ((WSAStartup  != NULL) &&
            (WSACleanup  != NULL) &&
            (socket      != NULL) &&
            (closesocket != NULL) &&
            (bind        != NULL) &&
            (getsockname != NULL))
            {
            if (!WSAStartup (WS_VERSION, &wd))
                {
                if (wd.wVersion == WS_VERSION)
                    {
                    if ((s = socket (AF_IPX, SOCK_DGRAM, NSPROTO_IPX))
                        != INVALID_SOCKET)
                        {
                        ZeroMemory (&sai, sizeof (sai));
                        sai.sa_family = AF_IPX;

                        n = sizeof (sai);
                        if ((!bind (s, (PSOCKADDR) &sai, n)) &&
                            (!getsockname (s, (PSOCKADDR) &sai, &n)))
                            {
                            CopyMemory (abAddress, sai.sa_nodenum,
                                        N_NIC_ADDRESS);
                            fOk = TRUE;
                            }
                        closesocket (s);
                        }
                    }
                WSACleanup ();
                }
            }
        FreeLibrary (hModule);
        }
    return fOk;
    }

// -----------------------------------------------------------------

BOOL WINAPI NicAddressVines (BYTE abAddress [N_NIC_ADDRESS])
    {
    HMODULE hModule;
    PROC    VnsDone, VnsGetNicAddress;
    DWORD   n;
    BOOL    fOk = FALSE;

    hModule = LoadLibrary ("VNSAPI32.dll");
    if (hModule != NULL)
        {
        VnsDone =
            GetProcAddress (hModule, "VnsDone");

        VnsGetNicAddress =
            GetProcAddress (hModule, "VnsGetNicAddress");

        if ((VnsDone          != NULL) &&
            (VnsGetNicAddress != NULL))
            {
            n   = N_NIC_ADDRESS;
            fOk = ((WORD) VnsGetNicAddress (abAddress, &n)
                   == VNS_BYCALLOK);

            VnsDone ();
            }
        FreeLibrary (hModule);
        }
    return fOk;
    }

// -----------------------------------------------------------------

BOOL WINAPI NicAddressRegistry (BYTE abAddress [N_NIC_ADDRESS])
    {
    HKEY  hk;
    DWORD dType, dSize, dLocal;
    BOOL  fOk = FALSE;

    if (RegOpenKeyEx (HKEY_LOCAL_MACHINE,
                      "SOFTWARE\\Description\\Microsoft\\Rpc\\"
                      "UuidTemporaryData",
                      0, KEY_QUERY_VALUE, &hk)
        == ERROR_SUCCESS)
        {
        dSize = sizeof (dLocal);

        if ((RegQueryValueEx (hk, "NetworkAddressLocal", NULL,
                              &dType, (PBYTE) &dLocal, &dSize)
             == ERROR_SUCCESS)
            &&
            (dType == REG_DWORD) &&
            (dSize == sizeof (dLocal)) && (!dLocal))
            {
            dSize = N_NIC_ADDRESS;

            if ((RegQueryValueEx (hk, "NetworkAddress", NULL,
                                  &dType, abAddress, &dSize)
                 == ERROR_SUCCESS)
                &&
                (dType == REG_BINARY) &&
                (dSize == N_NIC_ADDRESS))
                {
                fOk = TRUE;
                }
            }
        RegCloseKey (hk);
        }
    return fOk;
    }

// -----------------------------------------------------------------

BOOL WINAPI NicAddressAuto (BYTE abAddress [N_NIC_ADDRESS])
    {
    return (NicAddressNetbios  (abAddress) ||
            NicAddressNetware  (abAddress) ||
            NicAddressVines    (abAddress) ||
            NicAddressRegistry (abAddress));
    }

// -----------------------------------------------------------------

PTBYTE WINAPI NicAddressString (DWORD  dType,
                                TBYTE  atAddress [N_NIC_STRING],
                                PTBYTE ptError)
    {
    BYTE  abAddress [N_NIC_ADDRESS];
    DWORD i, j;
    BOOL  fOk;

    switch (dType)
        {
        case NIC_TYPE_AUTO:
            fOk = NicAddressAuto (abAddress);
            break;

        case NIC_TYPE_NETBIOS:
            fOk = NicAddressNetbios (abAddress);
            break;

        case NIC_TYPE_NETWARE:
            fOk = NicAddressNetware (abAddress);
            break;

        case NIC_TYPE_VINES:
            fOk = NicAddressVines (abAddress);
            break;

        case NIC_TYPE_REGISTRY:
            fOk = NicAddressRegistry (abAddress);
            break;

        default:
            fOk = FALSE;
            break;
        }
    if (fOk)
        {
        for (i = j = 0; i < N_NIC_ADDRESS; i++)
            {
            atAddress [j++] = atHex [abAddress [i] >>  4];
            atAddress [j++] = atHex [abAddress [i] & 0xF];
            }
        atAddress [j] = 0;
        }
    return (fOk ? atAddress
                : (ptError != NULL ? ptError : "N/A"));
    }


